#! /usr/bin/env bash
# Copyright 2020 UCLouvain
#
# Permission is hereby granted, free of charge, to any person obtaining a copy of
# this software and associated documentation files (the "Software"), to deal in
# the Software without restriction, including without limitation the rights to
# use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
# of the Software, and to permit persons to whom the Software is furnished to do
# so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

# Attack script. Do not use directly, use "main.sh attack" instead.

SCRIPT=$(readlink -f $0)
export SCRIPTPATH=`dirname $SCRIPT`

export CTF_ATTACK_SCRIPT=$CTF_PLAN_TYPE/attack

export CTF_DATA_DIR=$CTF_BASE_DIR/attack/$CTF_PLAN_TYPE/$CTF_N_TRACES/$CTF_ATTACK_SET

export CTF_PROFILE_SCRATCH=$CTF_BASE_DIR/profile/$CTF_PLAN_TYPE/profile_scratch
export CTF_ATTACK_SCRATCH=$CTF_DATA_DIR/attack_scratch

MAKE_CHALLENGE="$SCRIPTPATH/make_challenge.sh $CTF_CHALLENGE_DIR $CTF_CHALLENGE_TMP /challenge_dir_traces"
export CTF_CHALLENGE_DIR_TRACES=$CTF_CHALLENGE_DIR/$CTF_PLAN_TYPE/fixed_key/key_$CTF_ATTACK_SET
export CTF_CHALLENGE_DIR=`$MAKE_CHALLENGE $CTF_PLAN_TYPE $CTF_N_TRACES $CTF_ATTACK_SET`

rm -rf $CTF_DATA_DIR

$SCRIPTPATH/contain.sh $CTF_ATTACK_RAM $CTF_ATTACK_CPU $SCRIPTPATH/run_eval.sh attack

DIR_SIZE=$SCRIPTPATH/utils/dir_size.sh
CTF_UNPACK_SIZE=`$DIR_SIZE $CTF_SUBMISSION_DIR`
CTF_SETUP_SIZE=`$DIR_SIZE $CTF_EVAL_IMG`
PROFILE_SIZE=`$DIR_SIZE $CTF_PROFILE_SCRATCH`
ATTACK_SIZE=`$DIR_SIZE $CTF_DATA_DIR`
TOT_SIZE=$(($CTF_UNPACK_SIZE + $CTF_SETUP_SIZE + $PROFILE_SIZE + $ATTACK_SIZE))

if (($TOT_SIZE > $CTF_MAX_SIZE))
then
    echo "Fail size for attack $CTF_PLAN_TYPE/$CTF_N_TRACES/$CTF_ATTACK_SET, attack size: $ATTACK_SIZE" >&2
    rm -rf $CTF_DATA_DIR
    exit -1
fi

rm -rf $CTF_ATTACK_SCRATCH
