#! /usr/bin/env bash
# Copyright 2020 UCLouvain
#
# Permission is hereby granted, free of charge, to any person obtaining a copy of
# this software and associated documentation files (the "Software"), to deal in
# the Software without restriction, including without limitation the rights to
# use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
# of the Software, and to permit persons to whom the Software is furnished to do
# so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

# Ranking script. Do not use directly, use "main.sh rank" instead.

SCRIPT=$(readlink -f $0)
export SCRIPTPATH=`dirname $SCRIPT`

export CTF_DATA_DIR=$CTF_BASE_DIR/attack/$CTF_PLAN_TYPE/$CTF_N_TRACES/$CTF_ATTACK_SET

if [ "$CTF_SECURE_DIR" = "1" ]
then
    DIR_FILE=$CTF_CHALLENGE_DIR/$CTF_PLAN_TYPE/fixed_key/name_map_key_${CTF_ATTACK_SET}.txt
    KEY_STORE_FNAME=$(grep "^secret_" < $DIR_FILE |  cut -d ' ' -f 2)
else
    KEY_STORE_FNAME=secret_${CTF_PLAN_TYPE}_K${CTF_ATTACK_SET}.txt
fi

CORRECT_KEY=$(<$CTF_CHALLENGE_DIR/$CTF_PLAN_TYPE/fixed_key/key_${CTF_ATTACK_SET}/$KEY_STORE_FNAME)

RANK=$($SCRIPTPATH/ranking/rank.sh $CORRECT_KEY  < $CTF_DATA_DIR/reports/attack.res) \
    || (echo "FAIL rank $CTF_PLAN_TYPE/$CTF_N_TRACES/$CTF_ATTACK_SET" && exit -1)

RANK_FILE=$CTF_TEMP_RANKING_DIR/${CTF_PLAN_TYPE}_${CTF_N_TRACES}_${CTF_ATTACK_SET}.txt
echo "$RANK" > $RANK_FILE

