#! /usr/bin/env bash
# Copyright 2020 UCLouvain
#
# Permission is hereby granted, free of charge, to any person obtaining a copy of
# this software and associated documentation files (the "Software"), to deal in
# the Software without restriction, including without limitation the rights to
# use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
# of the Software, and to permit persons to whom the Software is furnished to do
# so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.


BASE_DIR=$1
DEST_DIR=$2
REL_DIR=$3
PLAN_TYPE=$4
N_TRACES=$5
ATTACK_SET=$6

RES_DIR=$DEST_DIR/${PLAN_TYPE}_${N_TRACES}_${ATTACK_SET}
rm -rf $RES_DIR
mkdir -p $RES_DIR

SET_SIZES=(100000 10000 1000 100 10 1)

for SET_SIZE in ${SET_SIZES[@]}; do
    i=0;
    while (($N_TRACES >= $SET_SIZE))
    do
        SRC_FNAME=fkey_${PLAN_TYPE}_K${ATTACK_SET}_${SET_SIZE}_${i}.npz
        if [ "$CTF_SECURE_DIR" = "1" ]
        then
            DIR_FILE=$BASE_DIR/$PLAN_TYPE/fixed_key/name_map_key_${ATTACK_SET}.txt
            SECRET_FNAME=$(grep "^$SRC_FNAME" < $DIR_FILE |  cut -d ' ' -f 2)
        else
            SECRET_FNAME=$SRC_FNAME
        fi
        SRC_FILE=$REL_DIR/$SECRET_FNAME
        DST_FILE=$RES_DIR/$fkey_${PLAN_TYPE}_K0_${SET_SIZE}_${i}.npz
        ln -s $SRC_FILE $DST_FILE
        N_TRACES=$(($N_TRACES - $SET_SIZE))
        i=$(($i + 1))
    done
done
if (($N_TRACES != 0))
then
    exit -1
fi

echo $RES_DIR
