#! /usr/bin/env bash
# Copyright 2020 UCLouvain
#
# Permission is hereby granted, free of charge, to any person obtaining a copy of
# this software and associated documentation files (the "Software"), to deal in
# the Software without restriction, including without limitation the rights to
# use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
# of the Software, and to permit persons to whom the Software is furnished to do
# so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

# Key ranking script
# Usage `./rank.sh <CORRECT_KEY> < attack.log`.
# CORRECT_KEY must be in hexadecimal
# attack.log must have the following format
# MSK:L0,L1,L2...,L255
# where MSK is a 128-bit HEX bitmask with 8 bits set to 1, L0 (resp LX) is the
# log-likelihood that the concatenation of the bits selected by the mask is
# equal to 0 (resp. X).
# There must thus be 16 lines, to cover all the 128 bits, each must cover distinct bits.

SCRIPT=$(readlink -f $0)
SCRIPTPATH=`dirname $SCRIPT`
SG_IMG=$SCRIPTPATH/rank_cnt.sif

CORRECT_KEY=$1

SINGULARITY_OPTIONS="--no-home --containall --hostname ctf --bind $SCRIPTPATH/mnt:/mnt:ro"

singularity exec $SINGULARITY_OPTIONS $SG_IMG /mnt/rank_script $CORRECT_KEY
