# Stella: Side-channel Tool-box for Embedded systems Lazy Leakage Analysis 

Stella is a library to perform simple leakage analysis in the context of side-channel attacks. This is a zero version containing a limited number of features used in the Spook CTF. The philosophy of stella is to keep computationally intensive operations in low level languages (Rust) with multithread while keeping easy Python interface. 

It has been developed by Olivier Bronchain at UCLouvain, 2019-2020.  (btw, stella is a belgian beer too ;))

## Main Features
*  SNR: Compute SNR on multiple variables at first order. Typically used for software implementations
*  SNROrder: Compute (univariate) SNR at arbitrary order in one pass. It computes all the standardized moments thanks to [Schneider and Moradi](https://www.iacr.org/archive/ches2015/92930478/92930478.pdf) method.
*  MCP_DPA: Perform univariate profiled CPA at any order thanks to [Moradi and Standaert](https://eprint.iacr.org/2014/409.pdf).
*  Rank estimation: estimate the rank of a 128-bit key thanks to [Poussier et al.](https://eprint.iacr.org/2016/571). There, stella reuses the already available code.

## Install

install rust

```
curl --proto '=https' --tlsv1.2 -sSf https://sh.rustup.rs | sh

```
Use rust nightly version by default. This is required for the Python interface
```
rustup toolchain install nightl
rustup default nightly
```
Build rust code
```
cd rust_stella
cargo build --release
cd ..
```
Add this dir to your PYTHONPATH to call it from everywhere
```
export PYTHONPATH=$PYTHONPATH:/DIR/CONTAINING/STELLA
```
